/*
 * gc global variable provides access to GUI Composer infrastructure components and project information.
 * For more information, please see the Working with Javascript guide in the online help.
 */

//I will store all the hardcoded variables here, so that way next IC GUI only requires change in one file

//Code needed to write register values
//const codec = registerModel.getCodec();

//const COMPATIBLE_EVMID_REGEX = /TMAG/;
//const FIRMWARE_VERSION = 20201209164335;
const FIRMWARE_VERSION = 20191210164335;
//const FIRMWARE_VERSION = 20210514220537;
//20210303172828


//EVM Definition for pambCustomCodec.js
const EVMID = /TMAG5273EVM/;

//Used in Plot.js
// let devVersion = 0;
// let xRange = 0;
// let yRange = 0;
// let zRange = 0;
// let mRange = 0;
// let aEnable = 0;
// let toggleLEDcur = 0;
// let toggleLEDprev = 0;
// let toggleLEDstate = 0;
// let pushThresh = 90;


const icObject ={
    
    xrange: 'my_register_model.user.sensor_config_2.x_y_range',
    xval: ('my_register_model.user.x_msb_result.x_ch_result_15_8' <<8) + 'my_register_model.user.x_lsb_result.x_ch_result_7_0',
    
    yrange: 'my_register_model.user.sensor_config_2.x_y_range',
    yval: ('my_register_model.user.y_msb_result.y_ch_result_15_8' <<8) + 'my_register_model.user.y_lsb_result.y_ch_result_7_0',
    
    zrange: 'my_register_model.user.sensor_config_2.z_range',
    zval: ('my_register_model.user.z_msb_result.z_ch_result_15_8' <<8) + 'my_register_model.user.z_lsb_result.z_ch_result_7_0',
    
    tempval: ('my_register_model.user.t_msb_result.t_ch_result_15_8' <<8) + 'my_register_model.user.t_lsb_result.t_ch_result_7_0',
    
    angleResult: ('my_register_model.user.angle_result_msb.angle_result_msb' <<8) + 'my_register_model.user.angle_result_msb.angle_result_lsb',
    
    magResult: 'my_register_model.user.magnitude_result.magnitude_result',
    //misc
    version:'my_register_model.user.device_id.device_id',
    enAngle:'my_register_model.user.sensor_config_2.angle_en', 
    
    
    //device specific functions
    //functions calls are icObject. xxxxx
    
    //configuration for rotate and push widget -> bind to button click event
    //TODO: WR to correct register to setup for TMAG5273 
    //TODO: Bind to button click event\
    //TODO: Write function that also verifies registers were sucessfully changed
     configureRP(){ 
         /*
         const codec = registerModel.getCodec();
         var currentRegState;
         var writeValue;
         //Gather all necessary bindings
          
         //1. • Make sure that the DEVICE_CONFIG -> OPERATING_MODE says "(TRIGGER_MODE Active)"
       
        currentRegState = codec.readRegister("0x1");
        
        writeValue = currenRegState ^ 0x02; //sets bits 1-3 to 0x1 for trigger mode
        
        codec.writeRegister("0x1",writeValue); //set to TRIGGER_MODE
        
        //TODO: FIX this 
         //2. • Make sure that SYSTEM_CONFIG -> TRIGGER_MODE is set to the default value
        currentRegState = codec.readRegister("0xA");
        writeValue = currenRegState ^ 0x01;
        codec.writeRegister("0xA",writeValue); 
         
         //3.• Make sure both the x and y channels are enabled (MAG_CH_EN) ->SENSOR_CONFIG_1
         currentRegState = codec.readRegister("0x2");
        writeValue = currenRegState ^ 0x30;
        codec.writeRegister("0x2",writeValue); 
         
         //TODO: Check version
         //4. • Set X_RANGE and Y_RANGE to ±100mT for A1 versions, and ±133mT for A2 versions -> in SENSOR_CONFIG_2
         currentRegState = codec.readRegister("0x3");
        writeValue = hex2bin(currentRegState)^ 0x30;
        writeValue = currenRegState ^ 0x30;
        codec.writeRegister("0x3",writeValue); */
         
         
         //7. • At the top of the register map, set "Auto Read" to "As fast as possible"
         
         //my_register_model.user.auto-read-value = 0;
         
         //8.• If necessary: Adjust the “Push threshold calibration” value above to be about 3-5mT larger than the absolute value of the min/max mT value from the X and Y channels across a 360° rotation
    
        //gc.console.debug("pambCustomCodec.js", "Configure Rotate and Push Succesful:  " + my_register_model.user.auto-read-value.value);
     }

};

//Helper functions

function hex2bin(hex){
    return (parseInt(hex, 16).toString(2)).padStart(8, '0');
}